#include <iostream>


#include <fggl/gfx/window.hpp>
#include <fggl/gfx/ogl.hpp>
#include <fggl/gfx/renderer.hpp>
#include <fggl/gfx/shader.hpp>
#include <fggl/data/procedural.hpp>
#include <fggl/debug/debug.h>
#include <fggl/data/storage.hpp>

int main(int argc, char* argv[]) {
	fggl::gfx::Context ctx;

	// build our main window
	fggl::gfx::Window win;
	win.fullscreen( true );

	// opengl time
	fggl::gfx::Graphics ogl(win);
	fggl::gfx::MeshRenderer meshRenderer;

	fggl::debug::DebugUI debug(win);
	debug.visible(false);

	fggl::data::Storage storage;
	fggl::gfx::ShaderCache cache(storage);

	fggl::gfx::ShaderConfig config;
	config.name = "unlit";
	config.vertex = "unlit_vert.glsl";
	config.fragment = "unlit_frag.glsl";
	cache.load(config);

	// generate meshes
	std::vector<fggl::data::Model> scene;

/*	fggl::data::Model model;
	fggl::data::Mesh cube = fggl::data::make_cube();
	model.append(cube);
	scene.push_back( model );*/

	while( !win.closeRequested() ) {
		ctx.pollEvents();
		debug.frameStart();

		// update step

		// render step
		ogl.clear();
		meshRenderer.render(scene);

		debug.draw();
		win.swap();
	}

	return 0;
}
