#include <fggl/gfx/ogl.hpp>

#include <stdexcept>

using namespace fggl::gfx;

Graphics::Graphics(Window& window) : m_window(window) {
	window.activate();
	GLenum err = glewInit();
	if ( GLEW_OK != err ) {
		throw std::runtime_error("couldn't init glew");
	}
}

Graphics::~Graphics() {
}

void Graphics::clear() {
	m_window.activate();

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
}
